# BlisParams Class Reference

`#include <BlisParams.h>`

Inheritance diagram for BlisParams:
[legend]
Collaboration diagram for BlisParams:
[legend]

List of all members.

## Public Types
enum | boolParams { useCons, useHeuristics, cutDuringRampup, endOfBoolParams }
| Character parameters. More...
enum | intParams { strongCandSize, branchStrategy, heurRound, cutClique, cutGomory, cutFlowCover, cutKnapsack, cutMir, cutOddHole, cutProbing, cutTwoMir, pseudoRelibility, lookAhead, endOfIntParams, branchStrategy, branchStrategyRampUp, cutStrategy, cutGenerationFrequency, cutPass, quickCutPass, cutCliqueStrategy, cutGomoryStrategy, cutFlowCoverStrategy, cutKnapsackStrategy, cutMirStrategy, cutOddHoleStrategy, cutProbingStrategy, cutTwoMirStrategy, cutCliqueFreq, cutGomoryFreq, cutFlowCoverFreq, cutKnapsackFreq, cutMirFreq, cutOddHoleFreq, cutProbingFreq, cutTwoMirFreq, difference, heurStrategy, heurCallFrequency, heurRoundStrategy, heurRoundFreq, lookAhead, pseudoRelibility, sharePcostDepth, sharePcostFrequency, strongCandSize, endOfIntParams }
| Integer paramters. More...
enum | dblParams { integerTol, cutoffInc, optimalRelGap, optimalAbsGap, pseudoWeight, cutFactor, denseConFactor, scaleConFactor, endOfDblParams, cutFactor, cutoff, cutoffInc, denseConFactor, integerTol, objSense, optimalRelGap, optimalAbsGap, pseudoWeight, scaleConFactor, tailOff, endOfDblParams }
| Double parameters. More...
enum | strParams { strDummy, endOfStrParams, strDummy, endOfStrParams }
| String parameters. More...
enum | strArrayParams { strArrayDummy, endOfStrArrayParams, strArrayDummy, endOfStrArrayParams }
| There are no string array parameters. More...
enum | chrParams { cutRampUp, presolve, shareConstraints, shareVariables, sharePseudocostRampUp, sharePseudocostSearch, endOfChrParams }
| Character parameters. More...
enum | intParams { strongCandSize, branchStrategy, heurRound, cutClique, cutGomory, cutFlowCover, cutKnapsack, cutMir, cutOddHole, cutProbing, cutTwoMir, pseudoRelibility, lookAhead, endOfIntParams, branchStrategy, branchStrategyRampUp, cutStrategy, cutGenerationFrequency, cutPass, quickCutPass, cutCliqueStrategy, cutGomoryStrategy, cutFlowCoverStrategy, cutKnapsackStrategy, cutMirStrategy, cutOddHoleStrategy, cutProbingStrategy, cutTwoMirStrategy, cutCliqueFreq, cutGomoryFreq, cutFlowCoverFreq, cutKnapsackFreq, cutMirFreq, cutOddHoleFreq, cutProbingFreq, cutTwoMirFreq, difference, heurStrategy, heurCallFrequency, heurRoundStrategy, heurRoundFreq, lookAhead, pseudoRelibility, sharePcostDepth, sharePcostFrequency, strongCandSize, endOfIntParams }
| Integer paramters. More...
enum | dblParams { integerTol, cutoffInc, optimalRelGap, optimalAbsGap, pseudoWeight, cutFactor, denseConFactor, scaleConFactor, endOfDblParams, cutFactor, cutoff, cutoffInc, denseConFactor, integerTol, objSense, optimalRelGap, optimalAbsGap, pseudoWeight, scaleConFactor, tailOff, endOfDblParams }
| Double parameters. More...
enum | strParams { strDummy, endOfStrParams, strDummy, endOfStrParams }
| String parameters. More...
enum | strArrayParams { strArrayDummy, endOfStrArrayParams, strArrayDummy, endOfStrArrayParams }
| There are no string array parameters. More...
## Public Member Functions
virtual void | createKeywordList ()
| Method for creating the list of keyword looked for in the parameter file.
virtual void | setDefaultEntries ()
| Method for setting the default values for the parameters.
void | setEntry (const boolParams key, const char *val)
| char* is true(1) or false(0), not used
void | setEntry (const boolParams key, const char val)
| char is true(1) or false(0), not used
void | setEntry (const boolParams key, const bool val)
| This method is the one that ever been used.
void | setEntry (const intParams key, const char *val)
void | setEntry (const intParams key, const int val)
void | setEntry (const dblParams key, const char *val)
void | setEntry (const dblParams key, const double val)
void | setEntry (const strParams key, const char *val)
void | setEntry (const strArrayParams key, const char *val)
virtual void | createKeywordList ()
| Method for creating the list of keyword looked for in the parameter file.
virtual void | setDefaultEntries ()
| Method for setting the default values for the parameters.
void | setEntry (const chrParams key, const char *val)
| char* is true(1) or false(0), not used
void | setEntry (const chrParams key, const char val)
| char is true(1) or false(0), not used
void | setEntry (const chrParams key, const bool val)
| This method is the one that ever been used.
void | setEntry (const intParams key, const char *val)
void | setEntry (const intParams key, const int val)
void | setEntry (const dblParams key, const char *val)
void | setEntry (const dblParams key, const double val)
void | setEntry (const strParams key, const char *val)
void | setEntry (const strArrayParams key, const char *val)
Constructors.
| BlisParams ()
| The default constructor creates a parameter set with from the template argument structure.
| BlisParams ()
| The default constructor creates a parameter set with from the template argument structure.
Query methods
For user application: Following code are do NOT need to change. The reason can not put following functions in base class `AlpsParameterSet` is that `chrParams` and `endOfChrParams` etc., are NOT the same as those declared in base class. The members of the parameter set can be queried for using the overloaded entry() method. Using the example in the class documentation the user can get a parameter with the "<code>param.entry(USER_par::parameter_name)</code>" expression.
bool | entry (const boolParams key) const
int | entry (const intParams key) const
double | entry (const dblParams key) const
const std::string & | entry (const strParams key) const
const std::vector< std::string > & | entry (const strArrayParams key) const
bool | entry (const chrParams key) const
int | entry (const intParams key) const
double | entry (const dblParams key) const
const std::string & | entry (const strParams key) const
const std::vector< std::string > & | entry (const strArrayParams key) const
Packing/unpacking methods
void | pack (AlpsEncoded &buf)
| Pack the parameter set into the buffer (AlpsEncoded is used as buffer Here).
void | unpack (AlpsEncoded &buf)
| Unpack the parameter set from the buffer.
void | pack (AlpsEncoded &buf)
| Pack the parameter set into the buffer (AlpsEncoded is used as buffer Here).
void | unpack (AlpsEncoded &buf)
| Unpack the parameter set from the buffer.

## Detailed Description

Definition at line 35 of file BlisParams.h.

## Member Enumeration Documentation

enum BlisParams::boolParams

Character parameters.

All of these variable are used as booleans (ture = 1, false = 0).

Enumerator:

  useCons | Whether generate cuts at all. Default: true.
  useHeuristics | Whether call heuristics. Default: true.
  cutDuringRampup | Whether generate cuts during rampup. Default: false.
  endOfBoolParams |

Definition at line 39 of file BlisParams.h.

enum BlisParams::intParams

Integer paramters.

Enumerator:

  strongCandSize | The number of candidate used in strong branching. Default: 10.
  branchStrategy | -1: disable, 0: default, 1: verbose. Branching strategy. Default: 0 logLevel, Branching strategy. 0: max infeasibilty, 1: pseudocost, 2: relibility, 3: strong branching. 0: max infeasibilty, 1: pseudocost, 2: relibility, 3: strong branching. 4: bilevel branching
  heurRound | Heuristics control. -1: disable, 0: default, 1: moderate, 2: aggressive.
  cutClique | Cut generators control. -1: disable, 0: default, 1: moderate, 2: aggressive.
  cutGomory |
  cutFlowCover |
  cutKnapsack |
  cutMir |
  cutOddHole |
  cutProbing |
  cutTwoMir |
  pseudoRelibility | The relibility of pseudocost.
  lookAhead | The look ahead of pseudocost.
  endOfIntParams |
  branchStrategy | -1: disable, 0: default, 1: verbose. Branching strategy. Default: 0 logLevel, Branching strategy. 0: max infeasibilty, 1: pseudocost, 2: relibility, 3: strong branching. 0: max infeasibilty, 1: pseudocost, 2: relibility, 3: strong branching. 4: bilevel branching
  branchStrategyRampUp |
  cutStrategy | Cut generators control. -2: root, -1: auto, 0: disable, any positive frequency
  cutGenerationFrequency | All constraint generators.
  cutPass |
  quickCutPass | The pass to generate cuts.
  cutCliqueStrategy | The pass to generate cuts for quick branching.
  cutGomoryStrategy |
  cutFlowCoverStrategy |
  cutKnapsackStrategy |
  cutMirStrategy |
  cutOddHoleStrategy |
  cutProbingStrategy |
  cutTwoMirStrategy |
  cutCliqueFreq |
  cutGomoryFreq |
  cutFlowCoverFreq |
  cutKnapsackFreq |
  cutMirFreq |
  cutOddHoleFreq |
  cutProbingFreq |
  cutTwoMirFreq |
  difference | -1 auto, 0, no, any integer frequency
  heurStrategy | Heuristics control. BlisHeurStrategyRoot: root, BlisHeurStrategyAuto: auto, BlisHuerStrategyNone: disable, BlisHeurStrategyPeriodic: every 't' nodes
  heurCallFrequency | All heuristics.
  heurRoundStrategy |
  heurRoundFreq |
  lookAhead | The look ahead of pseudocost.
  pseudoRelibility | The relibility of pseudocost.
  sharePcostDepth | Maximum tree depth of sharing pseudocost.
  sharePcostFrequency | Frequency of sharing pseudocost.
  strongCandSize | The number of candidate used in strong branching. Default: 10.
  endOfIntParams |

Definition at line 51 of file BlisParams.h.

enum BlisParams::dblParams

Double parameters.

Enumerator:

  integerTol | Tolrence to treat as an integer. Tolerance to treat as an integer. Default: 1.0e-5
  cutoffInc | The value added to relaxation value when deciding fathom. Default:1.0e-6
  optimalRelGap | If the relative gap between best feasible and best relaxed fall into this gap, search stops. Default: 1.0e-6
  optimalAbsGap | If the absolute gap between best feasible and best relaxed fall into this gap, search stops. Default: 1.0e-4
  pseudoWeight | Weight used to calculate pseudocost.
  cutFactor | Limit the max number cuts applied at a node. maxNumCons = (CutFactor - 1) * numCoreConstraints.
  denseConFactor | Dense constraint factor.
  scaleConFactor | Scaling indicator of a constraint.
  endOfDblParams |
  cutFactor | Limit the max number cuts applied at a node. maxNumCons = (CutFactor - 1) * numCoreConstraints.
  cutoff | Cutoff any nodes whose objective value is higher than it.
  cutoffInc | The value added to relaxation value when deciding fathom. Default:1.0e-6
  denseConFactor | Dense constraint factor.
  integerTol | Tolrence to treat as an integer. Tolerance to treat as an integer. Default: 1.0e-5
  objSense | Objective sense: min = 1.0, max = -1.0.
  optimalRelGap | If the relative gap between best feasible and best relaxed fall into this gap, search stops. Default: 1.0e-6
  optimalAbsGap | If the absolute gap between best feasible and best relaxed fall into this gap, search stops. Default: 1.0e-4
  pseudoWeight | Weight used to calculate pseudocost.
  scaleConFactor | Scaling indicator of a constraint.
  tailOff | Tail off.
  endOfDblParams |

Definition at line 97 of file BlisParams.h.

enum BlisParams::strParams

String parameters.

Enumerator:

  strDummy |
  endOfStrParams |
  strDummy |
  endOfStrParams |

Definition at line 130 of file BlisParams.h.

enum BlisParams::strArrayParams

There are no string array parameters.

Enumerator:

  strArrayDummy |
  endOfStrArrayParams |
  strArrayDummy |
  endOfStrArrayParams |

Definition at line 137 of file BlisParams.h.

enum BlisParams::chrParams

Character parameters.

All of these variable are used as booleans (ture = 1, false = 0).

Enumerator:

  cutRampUp | Generate cuts during rampup. Default: true
  presolve | Presolve or not.
  shareConstraints | Share constraints Default: false.
  shareVariables | Share constraints Default: false.
  sharePseudocostRampUp | Share pseudocost during ramp up. Default: true
  sharePseudocostSearch | Share pseudocost during search Default: false.
  endOfChrParams |

Definition at line 39 of file BlisParams.h.

enum BlisParams::intParams

Integer paramters.

Enumerator:

  strongCandSize | The number of candidate used in strong branching. Default: 10.
  branchStrategy | -1: disable, 0: default, 1: verbose. Branching strategy. Default: 0 logLevel, Branching strategy. 0: max infeasibilty, 1: pseudocost, 2: relibility, 3: strong branching. 0: max infeasibilty, 1: pseudocost, 2: relibility, 3: strong branching. 4: bilevel branching
  heurRound | Heuristics control. -1: disable, 0: default, 1: moderate, 2: aggressive.
  cutClique | Cut generators control. -1: disable, 0: default, 1: moderate, 2: aggressive.
  cutGomory |
  cutFlowCover |
  cutKnapsack |
  cutMir |
  cutOddHole |
  cutProbing |
  cutTwoMir |
  pseudoRelibility | The relibility of pseudocost.
  lookAhead | The look ahead of pseudocost.
  endOfIntParams |
  branchStrategy | -1: disable, 0: default, 1: verbose. Branching strategy. Default: 0 logLevel, Branching strategy. 0: max infeasibilty, 1: pseudocost, 2: relibility, 3: strong branching. 0: max infeasibilty, 1: pseudocost, 2: relibility, 3: strong branching. 4: bilevel branching
  branchStrategyRampUp |
  cutStrategy | Cut generators control. -2: root, -1: auto, 0: disable, any positive frequency
  cutGenerationFrequency | All constraint generators.
  cutPass |
  quickCutPass | The pass to generate cuts.
  cutCliqueStrategy | The pass to generate cuts for quick branching.
  cutGomoryStrategy |
  cutFlowCoverStrategy |
  cutKnapsackStrategy |
  cutMirStrategy |
  cutOddHoleStrategy |
  cutProbingStrategy |
  cutTwoMirStrategy |
  cutCliqueFreq |
  cutGomoryFreq |
  cutFlowCoverFreq |
  cutKnapsackFreq |
  cutMirFreq |
  cutOddHoleFreq |
  cutProbingFreq |
  cutTwoMirFreq |
  difference | -1 auto, 0, no, any integer frequency
  heurStrategy | Heuristics control. BlisHeurStrategyRoot: root, BlisHeurStrategyAuto: auto, BlisHuerStrategyNone: disable, BlisHeurStrategyPeriodic: every 't' nodes
  heurCallFrequency | All heuristics.
  heurRoundStrategy |
  heurRoundFreq |
  lookAhead | The look ahead of pseudocost.
  pseudoRelibility | The relibility of pseudocost.
  sharePcostDepth | Maximum tree depth of sharing pseudocost.
  sharePcostFrequency | Frequency of sharing pseudocost.
  strongCandSize | The number of candidate used in strong branching. Default: 10.
  endOfIntParams |

Definition at line 62 of file BlisParams.h.

enum BlisParams::dblParams

Double parameters.

Enumerator:

  integerTol | Tolrence to treat as an integer. Tolerance to treat as an integer. Default: 1.0e-5
  cutoffInc | The value added to relaxation value when deciding fathom. Default:1.0e-6
  optimalRelGap | If the relative gap between best feasible and best relaxed fall into this gap, search stops. Default: 1.0e-6
  optimalAbsGap | If the absolute gap between best feasible and best relaxed fall into this gap, search stops. Default: 1.0e-4
  pseudoWeight | Weight used to calculate pseudocost.
  cutFactor | Limit the max number cuts applied at a node. maxNumCons = (CutFactor - 1) * numCoreConstraints.
  denseConFactor | Dense constraint factor.
  scaleConFactor | Scaling indicator of a constraint.
  endOfDblParams |
  cutFactor | Limit the max number cuts applied at a node. maxNumCons = (CutFactor - 1) * numCoreConstraints.
  cutoff | Cutoff any nodes whose objective value is higher than it.
  cutoffInc | The value added to relaxation value when deciding fathom. Default:1.0e-6
  denseConFactor | Dense constraint factor.
  integerTol | Tolrence to treat as an integer. Tolerance to treat as an integer. Default: 1.0e-5
  objSense | Objective sense: min = 1.0, max = -1.0.
  optimalRelGap | If the relative gap between best feasible and best relaxed fall into this gap, search stops. Default: 1.0e-6
  optimalAbsGap | If the absolute gap between best feasible and best relaxed fall into this gap, search stops. Default: 1.0e-4
  pseudoWeight | Weight used to calculate pseudocost.
  scaleConFactor | Scaling indicator of a constraint.
  tailOff | Tail off.
  endOfDblParams |

Definition at line 133 of file BlisParams.h.

enum BlisParams::strParams

String parameters.

Enumerator:

  strDummy |
  endOfStrParams |
  strDummy |
  endOfStrParams |

Definition at line 174 of file BlisParams.h.

enum BlisParams::strArrayParams

There are no string array parameters.

Enumerator:

  strArrayDummy |
  endOfStrArrayParams |
  strArrayDummy |
  endOfStrArrayParams |

Definition at line 181 of file BlisParams.h.

## Constructor & Destructor Documentation

BlisParams::BlisParams | ( |  | ) | `[inline]`

The default constructor creates a parameter set with from the template argument structure.

The keyword list is created and the defaults are set.

Definition at line 149 of file BlisParams.h.

BlisParams::BlisParams | ( |  | ) | `[inline]`

The default constructor creates a parameter set with from the template argument structure.

The keyword list is created and the defaults are set.

Definition at line 193 of file BlisParams.h.

## Member Function Documentation

virtual void BlisParams::createKeywordList | ( |  | ) | `[virtual]`

Method for creating the list of keyword looked for in the parameter file.

Implements AlpsParameterSet.

virtual void BlisParams::setDefaultEntries | ( |  | ) | `[virtual]`

Method for setting the default values for the parameters.

Implements AlpsParameterSet.

bool BlisParams::entry | ( | const boolParams | key | ) | const`[inline]`

Definition at line 192 of file BlisParams.h.

int BlisParams::entry | ( | const intParams | key | ) | const`[inline]`

Definition at line 194 of file BlisParams.h.

double BlisParams::entry | ( | const dblParams | key | ) | const`[inline]`

Definition at line 196 of file BlisParams.h.

const std::string& BlisParams::entry | ( | const strParams | key | ) | const`[inline]`

Definition at line 199 of file BlisParams.h.

const std::vector<std::string>& BlisParams::entry | ( | const strArrayParams | key | ) | const`[inline]`

Definition at line 202 of file BlisParams.h.

void BlisParams::setEntry | ( | const boolParams | key,
|  | const char * | val |
| ) |  |  | `[inline]`

char* is true(1) or false(0), not used

Definition at line 207 of file BlisParams.h.

void BlisParams::setEntry | ( | const boolParams | key,
|  | const char | val |
| ) |  |  | `[inline]`

char is true(1) or false(0), not used

Definition at line 210 of file BlisParams.h.

void BlisParams::setEntry | ( | const boolParams | key,
|  | const bool | val |
| ) |  |  | `[inline]`

This method is the one that ever been used.

Definition at line 213 of file BlisParams.h.

void BlisParams::setEntry | ( | const intParams | key,
|  | const char * | val |
| ) |  |  | `[inline]`

Definition at line 216 of file BlisParams.h.

void BlisParams::setEntry | ( | const intParams | key,
|  | const int | val |
| ) |  |  | `[inline]`

Definition at line 219 of file BlisParams.h.

void BlisParams::setEntry | ( | const dblParams | key,
|  | const char * | val |
| ) |  |  | `[inline]`

Definition at line 222 of file BlisParams.h.

void BlisParams::setEntry | ( | const dblParams | key,
|  | const double | val |
| ) |  |  | `[inline]`

Definition at line 225 of file BlisParams.h.

void BlisParams::setEntry | ( | const strParams | key,
|  | const char * | val |
| ) |  |  | `[inline]`

Definition at line 228 of file BlisParams.h.

void BlisParams::setEntry | ( | const strArrayParams | key,
|  | const char * | val |
| ) |  |  | `[inline]`

Definition at line 231 of file BlisParams.h.

void BlisParams::pack | ( | AlpsEncoded & | buf | ) | `[inline, virtual]`

Pack the parameter set into the buffer (AlpsEncoded is used as buffer Here).

Reimplemented from AlpsParameterSet.

Definition at line 240 of file BlisParams.h.

void BlisParams::unpack | ( | AlpsEncoded & | buf | ) | `[inline, virtual]`

Unpack the parameter set from the buffer.

Reimplemented from AlpsParameterSet.

Definition at line 253 of file BlisParams.h.

virtual void BlisParams::createKeywordList | ( |  | ) | `[virtual]`

Method for creating the list of keyword looked for in the parameter file.

Implements AlpsParameterSet.

virtual void BlisParams::setDefaultEntries | ( |  | ) | `[virtual]`

Method for setting the default values for the parameters.

Implements AlpsParameterSet.

bool BlisParams::entry | ( | const chrParams | key | ) | const`[inline]`

Definition at line 236 of file BlisParams.h.

int BlisParams::entry | ( | const intParams | key | ) | const`[inline]`

Definition at line 238 of file BlisParams.h.

double BlisParams::entry | ( | const dblParams | key | ) | const`[inline]`

Definition at line 240 of file BlisParams.h.

const std::string& BlisParams::entry | ( | const strParams | key | ) | const`[inline]`

Definition at line 243 of file BlisParams.h.

const std::vector<std::string>& BlisParams::entry | ( | const strArrayParams | key | ) | const`[inline]`

Definition at line 246 of file BlisParams.h.

void BlisParams::setEntry | ( | const chrParams | key,
|  | const char * | val |
| ) |  |  | `[inline]`

char* is true(1) or false(0), not used

Definition at line 251 of file BlisParams.h.

void BlisParams::setEntry | ( | const chrParams | key,
|  | const char | val |
| ) |  |  | `[inline]`

char is true(1) or false(0), not used

Definition at line 254 of file BlisParams.h.

void BlisParams::setEntry | ( | const chrParams | key,
|  | const bool | val |
| ) |  |  | `[inline]`

This method is the one that ever been used.

Definition at line 257 of file BlisParams.h.

void BlisParams::setEntry | ( | const intParams | key,
|  | const char * | val |
| ) |  |  | `[inline]`

Definition at line 260 of file BlisParams.h.

void BlisParams::setEntry | ( | const intParams | key,
|  | const int | val |
| ) |  |  | `[inline]`

Definition at line 263 of file BlisParams.h.

void BlisParams::setEntry | ( | const dblParams | key,
|  | const char * | val |
| ) |  |  | `[inline]`

Definition at line 266 of file BlisParams.h.

void BlisParams::setEntry | ( | const dblParams | key,
|  | const double | val |
| ) |  |  | `[inline]`

Definition at line 269 of file BlisParams.h.

void BlisParams::setEntry | ( | const strParams | key,
|  | const char * | val |
| ) |  |  | `[inline]`

Definition at line 272 of file BlisParams.h.

void BlisParams::setEntry | ( | const strArrayParams | key,
|  | const char * | val |
| ) |  |  | `[inline]`

Definition at line 275 of file BlisParams.h.

void BlisParams::pack | ( | AlpsEncoded & | buf | ) | `[inline, virtual]`

Pack the parameter set into the buffer (AlpsEncoded is used as buffer Here).

Reimplemented from AlpsParameterSet.

Definition at line 284 of file BlisParams.h.

void BlisParams::unpack | ( | AlpsEncoded & | buf | ) | `[inline, virtual]`

Unpack the parameter set from the buffer.

Reimplemented from AlpsParameterSet.

Definition at line 297 of file BlisParams.h.

The documentation for this class was generated from the following files:

- /home/coin/svn-release/Blis-0.94.1/Bcps/examples/Blis/BlisParams.h
- /home/coin/svn-release/Blis-0.94.1/Blis/src/BlisParams.h